diff options
author | Chris Lord <chris@openedhand.com> | 2005-01-24 21:55:51 +0000 |
---|---|---|
committer | Chris Lord <chris@openedhand.com> | 2005-01-24 21:55:51 +0000 |
commit | 11c50f1f8175522c8b051a02540b6eea7198a9f0 (patch) | |
tree | 0af94ffea47dfad998811c9a3973a07ab83e0d5e /packages/unionfs/unionroot | |
parent | 13f2ab4c2d889723f10ce69853fbf99592d9eb89 (diff) |
Update unionroot and make it ok for unionroot-utils
BKrev: 41f56ee7rTGHTsscs0Cx_5yS1RQSZg
Diffstat (limited to 'packages/unionfs/unionroot')
-rw-r--r-- | packages/unionfs/unionroot/init.unionroot | 90 |
1 files changed, 90 insertions, 0 deletions
diff --git a/packages/unionfs/unionroot/init.unionroot b/packages/unionfs/unionroot/init.unionroot index e69de29bb2..90aa4b015e 100644 --- a/packages/unionfs/unionroot/init.unionroot +++ b/packages/unionfs/unionroot/init.unionroot @@ -0,0 +1,90 @@ +#!/bin/sh + +INIT=/sbin/init.sysvinit +#OVERLAYS=/media/ram /media/cf /media/card +ROOTBACKUP=/media/realroot +UNION=/media/union +PATH=/usr/bin:/usr/sbin:/bin:/sbin + +if ! test -e ${INIT}; then + echo >&2 "ERROR: ${INIT} not found" + exit 1 +fi + +if test x"$*" != "x"; then + exec ${INIT} $* +fi + +if ! which unionctl; then + exec ${INIT} +fi + +nodupmount () { + opts="" + type="" + while true; do + if test "$1" = "-o"; then + shift + opts="-o $1" + shift + elif test "$1" = "-t"; then + shift + type="$1" + shift + else + break + fi + done + if test x"$2" = "x"; then + mountpt="$1" + else + device="$1" + mountpt="$2" + fi + mountmatch="^[^ ]+ $mountpt $type" + # echo "NOTE: grep -E -q \"$mountmatch\" /proc/mounts" + if grep -E -q "$mountmatch" /proc/mounts; then + return 0; + fi + if test x"$type" != "x"; then + type="-t $type" + fi + echo >&2 "NOTE: executing mount $type $opts $device $mountpt" + mkdir -p $mountpt + /bin/mount.busybox $type $opts $device $mountpt + ret="$?" + if test "$ret" = "0"; then + wemounted="$wemounted $mountpt" + fi + return $ret +} + +#set -x +wemounted="" +( + set -e + /bin/mount.busybox /proc + insmod /lib/modules/`uname -r`/kernel/fs/unionfs.o + nodupmount -t unionfs -o dirs=/.=rw none ${UNION} +# nodupmount -o bind / ${UNION}/${ROOTBACKUP} +# for OVERLAY in ${OVERLAYS}; do +# nodupmount ${OVERLAY} +# union-ctl /. --add --mode rw ${OVERLAY} +# nodupmount -o bind ${OVERLAY} ${UNION}/${OVERLAY} +# done + /bin/umount.busybox /proc +# nodupmount -o bind /proc ${UNION}/proc +# nodupmount -o bind / ${ROOTBACKUP} +) || ( + echo >&2 "ERROR: unable to setup mounts for chroot"; + if test x"$wemounted" != "x"; then + # cleanup + for mount in $wemounted; do + /bin/umount.busybox $mount + done + fi + exec ${INIT} +) +cd ${UNION} +pivot_root . ./${ROOTBACKUP} +exec chroot . ${INIT} |